
// example presented in paragraph 7.15 of the manual
// https://manifem.rd.ciencias.ulisboa.pt/manual-maniFEM.pdf
// a cone-like shape

#include "maniFEM.h"
using namespace maniFEM;


void test_on_angles ( Mesh interf, Cell ABC, Cell AB )

{	frontal_nb_of_coords = 3;
	std::cout << angle < Environment < ManifoldNoWinding, ISRContainer::Inactive, ExtProd3d < ManifoldNoWinding, ISRContainer::Inactive > > > ( interf, ABC, AB ) << std::endl;

}



int main ( )	 

{	Manifold RR3 ( tag::Euclid, tag::of_dim, 3 );
	Function xyz = RR3 .build_coordinate_system ( tag::Lagrange, tag::of_degree, 1 );
	Function x = xyz [0], y = xyz [1], z = xyz [2];

	Cell A ( tag::vertex, tag::of_coords, {  0.,  0.,  0. } );
	Cell B ( tag::vertex, tag::of_coords, { -1.,  0.,  0. } );
	Cell C ( tag::vertex, tag::of_coords, {  0.,  1.,  0. } );
	Cell D ( tag::vertex, tag::of_coords, {  0., -100.,  1. } );

	Cell AB ( tag::segment, A .reverse(), B );
	Cell AC ( tag::segment, A. reverse(), C );
	Cell AD ( tag::segment, A. reverse(), D );
	Cell BC ( tag::segment, B .reverse(), C );
	Cell BD ( tag::segment, B. reverse(), D );

	Cell ABC ( tag::triangle, AB, BC, AC .reverse() );
	Cell BAD ( tag::triangle, AB .reverse(), AD, BD .reverse() );

	Mesh interf ( tag::fuzzy, tag::of_dimension, 2 );
	ABC .add_to_mesh ( interf );
	BAD .add_to_mesh ( interf );

	test_on_angles ( interf, ABC, AB );

}




void main2 ( )

{	Manifold RR2 ( tag::Euclid, tag::of_dim, 2 );
	Function xy = RR2 .build_coordinate_system ( tag::Lagrange, tag::of_degree, 1 );
	Function x = xy [0], y = xy [1];

	const double pi = 3.1415926536;
	const double theta = pi/2.,  // radians
		cos_theta = std::cos ( theta ), sin_theta = std::sin ( theta );
	
	// define an action on RR2 (a rotation)
	Manifold::Action rot ( tag::transforms, xy, tag::into,
		( cos_theta * x - sin_theta * y ) && ( sin_theta * x + cos_theta * y ) );

	// and divide RR2 by the group generated by rot
	Manifold torus_manif = RR2 .quotient ( rot );

	Cell O ( tag::vertex );  x (O) = 0. ;  y (O) = 0. ;
	Cell A ( tag::vertex );  x (A) = 1. ;  y (A) = 0. ;
	Cell B ( tag::vertex );  x (B) = 1.2;  y (B) = 1.2;

	Mesh OA ( tag::segment, O .reverse(), A, tag::divided_in, 10 );  // no winding
	Mesh OB ( tag::segment, O .reverse(), B, tag::divided_in, 10 );  // no winding
	Mesh AB ( tag::segment, A .reverse(), B, tag::divided_in, 10 );  // no winding
	Mesh BA ( tag::segment, B .reverse(), A, tag::divided_in, 10, tag::winding, rot );

	Mesh sector ( tag::quadrangle, AB, BA, OA .reverse(), OA,
	              tag::winding, tag::singular, O, tag::with_triangles );

	sector .export_to_file ( tag::eps,"sector.eps", tag::unfold, { -rot, 0, rot },
	                         tag::over_region, -2.1 < x < 2.1, -0.3 < y < 2.1     );
	std::cout << "produced file sector.eps - please edit before viewing" << std::endl;

}  // end of main
